function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { print, printErrorAndExit, formatBold, formatDim, formatCode, formatDanger } from '@resdir/console';
import { get } from '@resdir/http-client';
import LocalCache from '@resdir/local-cache';
import { compareVersions } from '@resdir/version';
import { runExpression, runREPL } from '../';
var INSTALL_WEBSITE_URL = 'https://install.run.tools';
var INSTALL_COMMAND = "curl " + INSTALL_WEBSITE_URL + " | bash";
var LATEST_VERSION_CACHE_TIME = 3 * 24 * 60 * 60 * 1000; // 3 days

function start() {
  return _start.apply(this, arguments);
}

function _start() {
  _start = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var expression, printOutput, index, directory, output;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            expression = process.argv.slice(2);
            index = expression.indexOf('--@print');

            if (index === -1) {
              index = expression.indexOf('--@p');
            }

            if (index !== -1) {
              printOutput = true;
              expression.splice(index, 1);
            }

            expression = expression.map(function (arg) {
              return arg.replace(/\s/g, '\\ ');
            });
            expression = expression.join(' ');
            directory = process.cwd();

            if (!expression.includes('@version')) {
              _context2.next = 14;
              break;
            }

            _context2.t0 = print;
            _context2.next = 11;
            return getCurrentVersion();

          case 11:
            _context2.t1 = _context2.sent;
            (0, _context2.t0)(_context2.t1);
            return _context2.abrupt("return");

          case 14:
            if (!expression.includes('@repl')) {
              _context2.next = 18;
              break;
            }

            _context2.next = 17;
            return runREPL({
              directory: directory
            });

          case 17:
            return _context2.abrupt("return");

          case 18:
            _context2.next = 20;
            return runExpression(expression, {
              directory: directory
            });

          case 20:
            output = _context2.sent;

            if (!printOutput) {
              _context2.next = 25;
              break;
            }

            output.$print();
            _context2.next = 28;
            break;

          case 25:
            if (!(output && !output.$getIsMethodOutput())) {
              _context2.next = 28;
              break;
            }

            _context2.next = 28;
            return output['@help']();

          case 28:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _start.apply(this, arguments);
}

function checkVersion() {
  return _checkVersion.apply(this, arguments);
}

function _checkVersion() {
  _checkVersion = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3() {
    var currentVersion, latestVersion;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getCurrentVersion();

          case 2:
            currentVersion = _context3.sent;
            _context3.next = 5;
            return getLatestVersion();

          case 5:
            latestVersion = _context3.sent;

            if (latestVersion) {
              _context3.next = 8;
              break;
            }

            return _context3.abrupt("return");

          case 8:
            if (compareVersions(currentVersion, '<', latestVersion)) {
              print(formatBold("Run CLI update available " + formatDim("(" + currentVersion + " \u2192 " + latestVersion + ")")) + ", invoke " + formatCode(INSTALL_COMMAND) + " to update.");
            }

          case 9:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _checkVersion.apply(this, arguments);
}

function getCurrentVersion() {
  return _getCurrentVersion.apply(this, arguments);
}

function _getCurrentVersion() {
  _getCurrentVersion = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4() {
    var pkg;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            pkg = require('../../../../package.json');
            return _context4.abrupt("return", pkg.version);

          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getCurrentVersion.apply(this, arguments);
}

function getLatestVersion() {
  return _getLatestVersion.apply(this, arguments);
}

function _getLatestVersion() {
  _getLatestVersion = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5() {
    var cache, _ref2, body;

    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.prev = 0;
            cache = new LocalCache({
              time: LATEST_VERSION_CACHE_TIME
            });
            _context5.next = 4;
            return get(INSTALL_WEBSITE_URL + "/releases/latest.txt", {
              cache: cache,
              timeout: 5000
            });

          case 4:
            _ref2 = _context5.sent;
            body = _ref2.body;
            return _context5.abrupt("return", body.trim());

          case 9:
            _context5.prev = 9;
            _context5.t0 = _context5["catch"](0);
            print(formatDanger('An error occurred while checking the latest version') + " " + formatDim("(" + _context5.t0.message + ")"));
            return _context5.abrupt("return", undefined);

          case 13:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[0, 9]]);
  }));
  return _getLatestVersion.apply(this, arguments);
}

_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return checkVersion();

        case 2:
          _context.next = 4;
          return start();

        case 4:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
}))().catch(printErrorAndExit);