function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { Resource } from 'run-core';
import { session, print, printError, formatDim } from '@resdir/console';
export function runExpression(_x, _x2) {
  return _runExpression.apply(this, arguments);
}

function _runExpression() {
  _runExpression = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(expression, _temp) {
    var _ref, directory, resource, method;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (expression === void 0) {
              expression = '';
            }

            _ref = _temp === void 0 ? {} : _temp, directory = _ref.directory;
            _context2.next = 4;
            return Resource.$create(undefined, {
              directory: directory
            });

          case 4:
            resource = _context2.sent;
            _context2.next = 7;
            return Resource.$create({
              '@type': 'method',
              '@run': expression,
              '@output': {
                '@isOpen': true
              }
            }, {
              directory: directory
            });

          case 7:
            method = _context2.sent;
            _context2.next = 10;
            return session(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            regeneratorRuntime.mark(function _callee() {
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.next = 2;
                      return method.$call(resource);

                    case 2:
                      return _context.abrupt("return", _context.sent);

                    case 3:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            })));

          case 10:
            return _context2.abrupt("return", _context2.sent);

          case 11:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _runExpression.apply(this, arguments);
}

export function runREPL(_temp2) {
  var _ref2 = _temp2 === void 0 ? {} : _temp2,
      directory = _ref2.directory;

  return new Promise(function (resolve) {
    var readline = require('readline');

    var rl = readline.createInterface({
      input: process.stdin,
      output: process.stdout,
      prompt: formatDim('> ')
    });
    rl.prompt();
    rl.on('line', function (line) {
      runLine(line, {
        directory: directory
      }).then(function () {
        return rl.prompt();
      });
    });
    rl.on('close', function () {
      print('');
      resolve();
    });
  });
}

function runLine(_x3, _x4) {
  return _runLine.apply(this, arguments);
}

function _runLine() {
  _runLine = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(line, _ref3) {
    var directory, output;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            directory = _ref3.directory;
            line = line.trim();

            if (line) {
              _context3.next = 4;
              break;
            }

            return _context3.abrupt("return");

          case 4:
            _context3.prev = 4;
            _context3.next = 7;
            return runExpression(line, {
              directory: directory
            });

          case 7:
            output = _context3.sent;
            output.$print();
            _context3.next = 14;
            break;

          case 11:
            _context3.prev = 11;
            _context3.t0 = _context3["catch"](4);
            printError(_context3.t0);

          case 14:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[4, 11]]);
  }));
  return _runLine.apply(this, arguments);
}