"use strict";

exports.__esModule = true;
exports.runExpression = runExpression;
exports.runREPL = runREPL;

var _runCore = require("run-core");

var _console = require("@resdir/console");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function runExpression() {
  return _runExpression.apply(this, arguments);
}

function _runExpression() {
  _runExpression = _asyncToGenerator(function* (expression = '', {
    directory
  } = {}) {
    const resource = yield _runCore.Resource.$create(undefined, {
      directory
    });
    const method = yield _runCore.Resource.$create({
      '@type': 'method',
      '@run': expression,
      '@output': {
        '@isOpen': true
      }
    }, {
      directory
    });
    return yield (0, _console.session)(
    /*#__PURE__*/
    _asyncToGenerator(function* () {
      return yield method.$call(resource);
    }));
  });
  return _runExpression.apply(this, arguments);
}

function runREPL({
  directory
} = {}) {
  return new Promise(resolve => {
    const readline = require('readline');

    const rl = readline.createInterface({
      input: process.stdin,
      output: process.stdout,
      prompt: (0, _console.formatDim)('> ')
    });
    rl.prompt();
    rl.on('line', line => {
      runLine(line, {
        directory
      }).then(() => rl.prompt());
    });
    rl.on('close', () => {
      (0, _console.print)('');
      resolve();
    });
  });
}

function runLine(_x, _x2) {
  return _runLine.apply(this, arguments);
}

function _runLine() {
  _runLine = _asyncToGenerator(function* (line, {
    directory
  }) {
    line = line.trim();

    if (!line) {
      return;
    }

    try {
      const output = yield runExpression(line, {
        directory
      });
      output.$print();
    } catch (err) {
      (0, _console.printError)(err);
    }
  });
  return _runLine.apply(this, arguments);
}